'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsPureRenderMixin = require('react-addons-pure-render-mixin');

var _reactAddonsPureRenderMixin2 = _interopRequireDefault(_reactAddonsPureRenderMixin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Field = _react2.default.createClass({
  displayName: 'Field',

  mixins: [_reactAddonsPureRenderMixin2.default],

  makeErrorsList: function makeErrorsList(errors) {
    if (errors) {
      return _react2.default.createElement(
        'ul',
        { className: 'errors' },
        errors.map(function (e, i) {
          return e && _react2.default.createElement(
            'li',
            { key: i },
            e
          );
        })
      );
    } else {
      return null;
    }
  },

  showErrors: function showErrors(props) {
    var errOnDirty = props.errOnDirty;
    var dirty = props.dirty;

    return !errOnDirty || dirty;
  },


  labeledWidget: function labeledWidget(props) {
    var label = props.label;
    var _props$widget = props.widget;
    var widget = _props$widget === undefined ? 'input' : _props$widget;
    var children = props.children;

    if (label) {
      return _react2.default.createElement(
        'label',
        null,
        label,
        widget && _react2.default.createElement(widget, props, children)
      );
    } else {
      return widget && _react2.default.createElement(widget, props, children);
    }
  },

  render: function render() {
    var _this = this;

    var _props = this.props;
    var label = _props.label;
    var widget = _props.widget;
    var errors = _props.errors;
    var moreErrors = _props.moreErrors;
    var children = _props.children;

    if (widget === 'select') {
      children = _react2.default.Children.map(children, function (el) {
        return _react2.default.cloneElement(el, _this.props.fields[el.props.value]);
      });
    }
    return _react2.default.createElement(
      'div',
      { className: 'form-group' },
      this.labeledWidget(this.props),
      this.showErrors(this.props) && this.makeErrorsList([].concat(errors, moreErrors))
    );
  }
});

exports.default = Field;